unit CharCase;
{-----------------------------------------------------------------------------
                      UpCase/LoCase Handling Routines
                      (w) by Valery Votintsev, 1994
------------------------------------------------------------------------------}
interface

Function  UpCase(Ch:Char):Char;
Function  LoCase(Ch:Char):Char;

implementation

{------------------------------------------------------}
Function UpCase(Ch : Char) : Char; Assembler;
{Return uppercased char, with Russian character support}

Asm
        mov     al,ss:[bp+6]
       { -----------  Convert English Characters }
        CMP     AL,'a'
        JB      @1               { if AL < 'a'          }
        CMP     AL,'z'
        JA      @2               { if AL > 'z'          }
        SUB     AL,20H           { Convert to uppercase }
        JMP     @1
        { -----------  Convert Russian Characters}
@2:
       CMP AL,''
       JB  @1

       CMP AL,''
       JA  @3
       AND AL,0DFH      { Convert chars "..." }
        JMP     @1
@3:
       CMP AL,''
       JB  @1

       CMP AL,''
       JA  @4
       SUB AL,050H      { Convert chars "..." }
        JMP     @1
@4:
       CMP AL,''
       JNE @1
       DEC AL           { Convert e: -> E:        }
@1:
END;

{-------------------------------------------------------}
Function Locase(Ch : Char) : Char; Assembler;
{Return lowercased char, with Danish character support  }
Asm
        mov     al,ss:[bp+6]
        { -----------  Convert English Characters  }
        CMP     AL,'A'
        JB      @1                { if AL < 'A lat'}
        CMP     AL,'Z'
        JA      @2                { if AL > 'Z'    }
        ADD     AL,20H            { Convert to lowercase }
        JMP     @1
        { -----------  Convert Russian Characters }
@2:
       CMP AL,''                 { if AL < 'A rus'}
       JB  @1

       CMP AL,''                 { if AL > ' rus'}
       JA  @3
       ADD AL,20H      { Convert chars "..." }
        JMP     @1
@3:
       CMP AL,''
       JB  @1

       CMP AL,''
       JA  @4
       ADD AL,050H      { Convert chars "..." }
        JMP     @1
@4:
       CMP AL,''
       JNE @1
       INC AL           { Convert E: -> e:  }
@1:
END;

end.

